$!-----------------------------------------------------------------------------
$! BUILD_PERLRTE.COM
$! Perl Run-Time Environment.
$!
$! P1 == LINK or BUILD or empty (builds)
$! P2 == Optional location of CGILIB object library (defaults to [.MISC])
$!
$! 28-OCT-2000  MGD  use CGILIB object library
$! 23-MAY-2000  MGD  initial
$!-----------------------------------------------------------------------------
$!
$ WRITE SYS$OUTPUT ""
$ WRITE SYS$OUTPUT "Building ""PERLRTE""" +-
                   " for ""''F$GETSYI("ARCH_NAME")'"" architecture"
$!
$ ARCH_NAME = F$EDIT(F$GETSYI("ARCH_NAME"),"UPCASE")
$ IF ARCH_NAME .EQS. "ALPHA" THEN ARCH_NAME = "AXP"
$!
$ IF P1 .EQS. "" .OR. P1 .EQS. "BUILD"
$ THEN
$    IF F$INTEGER(F$EXTRACT(1,1,F$GETSYI("NODE_SWVERS"))) .LT. 7
$    THEN
$       WRITE SYS$OUTPUT "Build requires at least VMS V7.n"
$       EXIT
$    ENDIF
$    IF F$TRNLNM("PERL_ROOT") .EQS. ""
$    THEN
$       WRITE SYS$OUTPUT "Cannot build, ""PERL_ROOT"" not detected."
$       EXIT
$    ENDIF
$    IF F$SEARCH("PERL_ROOT:[000000]PERL.H") .EQS. "" .OR. -
        F$SEARCH("PERL_ROOT:[000000]EXTERN.H") .EQS. ""
$    THEN
$       WRITE SYS$OUTPUT "Cannot build, required header files are not available."
$       EXIT
$    ENDIF
$ ENDIF
$!
$ DEFINES = "/DEFINE=(CGILIB_OBJECT_MODULE)"
$ WARNINGS = "/WARNING=(DISABLE=(PREOPTW))"
$ INCLUDES = "/INCLUDE=(HT_ROOT:[SRC.MISC],PERL_ROOT:[000000])"
$!
$ IF F$SEARCH("OBJ_''ARCH_NAME'.DIR") .EQS. "" -
     THEN CREATE /DIR [.OBJ_'ARCH_NAME']
$ OBJECT_DIR = "[.OBJ_''ARCH_NAME']"
$!
$ IF F$EDIT(F$GETSYI("ARCH_NAME"),"UPCASE") .EQS. "VAX"
$ THEN
$    CC_OPTIONS = "/DECC /OPTIMIZE /STANDARD=RELAXED" +-
                  WARNINGS + DEFINES + INCLUDES
$ ELSE
$    CC_OPTIONS = "/DECC /OPTIMIZE /STANDARD=RELAXED" +-
                  WARNINGS + DEFINES + INCLUDES
$ ENDIF
$!
$ IF P1 .EQS. "" .OR. P1 .EQS. "BUILD" .OR. P1 .EQS. "COMPILE"
$ THEN
$    SET NOON
$    SET VERIFY
$    CC 'CC_OPTIONS' /OBJECT='OBJECT_DIR'PERLRTE PERLRTE
$    CC 'CC_OPTIONS' /OBJECT='OBJECT_DIR'PERLRTENG PERLRTENG
$!   'F$VERIFY(0)
$    SET ON
$ ENDIF
$!
$ IF P1 .EQS. "" .OR. P1 .EQS. "BUILD" .OR. P1 .EQS. "LINK"
$ THEN
$!
$    IF F$TRNLNM("PERLSHR") .EQS. ""
$    THEN
$       WRITE SYS$OUTPUT "Cannot link, ""PERLSHR"" not detected."
$       EXIT
$    ENDIF
$!
$    CGILIB_OLB = "HT_ROOT:[SRC.MISC.OBJ_''ARCH_NAME']CGILIB.OLB"
$    SET NOON
$    SET VERIFY
$    LINK /EXECUTABLE=HT_EXE:PERLRTE.EXE -
     'OBJECT_DIR'PERLRTE,'OBJECT_DIR'PERLRTENG, -
     'CGILIB_OLB'/LIBRARY, -
     SYS$INPUT:/OPTIONS
PERLSHR/Share
$!   'F$VERIFY(0)
$    SET ON
$ ENDIF
$ SET PROTECTION=W:RE HT_EXE:PERLRTE.EXE
$ PURGE /NOLOG 'OBJECT_DIR'
$!
$!-----------------------------------------------------------------------------
